<template>
  <ob-form
      :form-data="formData"
      :form-model="formModel"
      :is-show-controls="true"
      @submit="onSubmitHandler"
      :is-active-element="formData.isActive"
      @change-active="onChangeActive"
  >
    <div class="row">
      <div class="col-xs-12">
        <ob-selector
            v-model="formData.serviceTypeUuid"
            label="Тип услуги"
            :remote-opt="getServiceTypesList"
            :details-remote="{
              method: getService
            }"
            value-exp="uuid"
            :disabled="!isNew"
            display-exp="title"
            placeholder="Выберите"
        />
      </div>
    </div>
    <template v-if="formData.serviceTypeUuid">
      <div class="row">
        <div class="col-xs-12">
          <ob-input
              :label="dictionaryRu.modal.service_geography"
              :value="SERVICE_GEOGRAPHY[formData.geography]"
              :disabled="true"
          />
        </div>
      </div>
      <div
          v-if="needResources && resourceList.length"
          class="row"
      >
        <div class="col-xs-12">
          <table :class="{disabled: disabledForm}">
            <tr>
              <th>{{ dictionaryRu.modal.type }}</th>
              <th>{{ dictionaryRu.modal.sub_type }}</th>
              <th>{{ dictionaryRu.modal.pattern }}</th>
            </tr>
            <tr v-if="!resources || resources.length === 0">
              <td
                  colspan="3"
                  class="not-data"
              >
                {{ dictionaryRu.modal.no_data }}
              </td>
            </tr>
            <spec
                v-for="(spec, index) in resources"
                :key="index"
                v-model="formData"
                :spec="spec"
                :disabled-form="disabledForm"
                :resourceList="resourceList"
                :masks="masks"
                :resource-type-list="resourceTypeStream.types"
                :isNew="isNew"
                :selectedData="selectedData"
            />
          </table>
        </div>
      </div>
    </template>
    <div class="row">
      <div class="col-xs-12">
        <ob-selector
            label="Возможные единицы измерения"
            v-model="formData.serviceUnits"
            :remote-opt="getPointChanger"
            display-exp="name"
            value-exp="uuid"
            placeholder="Выберите минимум одну"
            :is-multiselect="true"
            :is-dropdown="true"
            :is-tagbox="true"
            :disabled="!isNew"
        />
      </div>
    </div>
    <ob-alert
        v-if="hasAlert"
        :hide-close-button="true"
        icon="alert"
        theme="danger"
        text="Точно такая же услуга уже есть. Нельзя создать дубль. Измените параметры создаваемой услуги."
    />
  </ob-form>
</template>

<script>
  import SERVICES_MIXIN from '@/mixins/enum/services';
  import FormValidationMixin from 'common-components/src/obComponents/obForm/FormValidationMixin';
  import Spec from './Spec';
  import api from '@/api';
  import cloneDeep from 'clone-deep';
  import models from '@/models';
  import ObForm from 'common-components/src/obComponents/obForm';
  import ObInput from 'common-components/src/obComponents/obInput';
  import ObSelector from 'common-components/src/obComponents/obSelect';
  import {dictionaryDefault} from '@/translations/ru/default'
  import {dictionary} from '@/translations/ru/dictionaries__services__services_list';
  import ObAlert from "common-components/src/obComponents/obAlert";

  export default {
    name: 'viewService',
    components: {
      ObForm,
      Spec,
      ObInput,
      ObSelector,
      ObAlert
    },
    data() {
      return {
        api,
        resources: [],
        needResources: false,
        resourceList: [],
        masks: [],
        dictionaryRu: Object.assign(dictionary, dictionaryDefault),
        hasAlert: false
      };
    },
    mixins: [FormValidationMixin, SERVICES_MIXIN],
    props: {
      disabledForm: {
        type: Boolean,
        default: true
      },
      isShowControls: {
        type: Boolean,
        default: true
      },
      selectedData: {
        type: Object,
        required: true,
        default: () => {
        }
      },
      serviceTypes: {
        type: Array,
        required: true,
        default: () => []
      },
      resourceTypeStream: {
        type: Object,
        default: () => {
        }
      }
    },
    watch: {
      'formData.serviceTypeUuid'() {
        if (this.formData.serviceTypeUuid) {
          this.selectServiceTypeUuid({
            uuid: this.formData.serviceTypeUuid
          });
        }
      }
    },
    computed: {
      formModel() {
        return models.service.add;
      },
      isNew() {
        return !this.formData.uuid;
      },
      enabledUnits() {
        return !this.dataSource.deleted_at || !this.dataSource.deleted_at.length;
      },
      dropdownMenu() {
        return this.isNew || this.dataSource.deleted_at
          ? null
          : [
            {
              title: this.dictionaryRu.dropdown_menu.delete,
              className: 'color-error',
              method: () => {
                this.$emit('delete');
              }
            }
          ];
      }
    },
    async mounted() {
      this.resourceList = await this.resourceTypeStream.getResources();
      this.masks = this.resourceTypeStream.getMasks();
    },
    methods: {
      async getServiceTypesList({ page, size, query }) {
        try {
          const res = await api.services.getServiceTypesList({ page, size, query });
          res.data.content = res.data.content.filter(item => item.isActive);
          return res;
        } catch (err) {
          console.error(err);
        }
      },
      async getService() {
        await this.$nextTick();
        if (!this.formData.serviceTypeUuid) return [];
        try {
          const { data } = await api.services.getServiceType(this.formData.serviceTypeUuid);
          return [{ ...data, uuid: this.formData.serviceTypeUuid }];
        } catch (err) {
          console.error(err);
        }
      },
      onChangeActive() {
        this.formData.isActive = !this.formData.isActive;
      },
      async selectServiceTypeUuid({uuid}) {
        try {
          let res = await this.api.services.getServiceType(uuid);
          this.needResources = res.data.needResources;
          this.resources = res.data.resourceSpecies;
          this.formData.geography = res.data.geography;
        } catch (e) {
          console.error(e);
          this.$notification({
            type: 'system_notification_error',
            message: 'Ошибка загрузки данных'
          });
        }
      },
      onSubmitHandler() {
        const data = cloneDeep(this.formData);
        this.$emit('submit', {
          formData: data,
          model: this.formModel
        });
      },
      async getPointChanger() {
        const {data} = await api.services.getServiceMeasurementUnits();
        let unique = [];
        data.content.forEach((item) => {
          if (item.is_active) {
            const i = unique.findIndex(x => x.uuid === item.uuid);
            if (i <= -1) {
              unique.push(item);
            }
          }
        });
        const result = Array.from(new Set(unique.map(s => s.name))).map(name => ({
          name: name,
          denomination: unique.find(q => q.name === name).denomination,
          is_active: unique.find(q => q.name === name).is_active,
          uuid: unique.find(q => q.name === name).uuid,
        }));

        return result;
      }
    }
  };
</script>

<style lang="scss" scoped>
  table {
    width: 100%;
    border-collapse: collapse;
    margin-bottom: 20px;

    th {
      text-transform: uppercase;
      font-variant: small-caps;
      padding: 10px;
      text-align: left;
      font-weight: normal;
    }

    .not-data {
      padding: 10px;
      text-align: center;
    }
  }
</style>
